package Ejer05_05_04;

import java.util.concurrent.locks.Condition;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

public class BufferSincLock {
	
	private static final int BUFFER_SIZE = 10;
	
	private int[] datos = new int [BUFFER_SIZE];
	private int posInser = 0;
	private int posSacar = 0;
	private int numProductos = 0;
	
	static Lock procesoslock = new ReentrantLock();
	static Condition lleno = procesoslock.newCondition();
	static Condition vacio = procesoslock.newCondition();
	
	
	public void insertar (int producido) throws InterruptedException {
		
		procesoslock.lock();
		
		while(numProductos == BUFFER_SIZE) {
			lleno.await();
		}
		datos[posInser]=producido;
		posInser = (posInser+1) % datos.length;
		numProductos++;
		
		vacio.signal();
		
		procesoslock.unlock();
	}
	
	public int sacar() throws InterruptedException{
		
		procesoslock.lock();
		
		while(numProductos == 0) {
			vacio.await();
			
		}
		int producido = datos[posSacar];
		posSacar = (posSacar+1) % datos.length;
		numProductos--;
		
		lleno.signal();

		procesoslock.unlock();
	
		return producido;

	}
}