package Ejer05_05_05a;

import java.util.concurrent.locks.Condition;
import java.util.concurrent.locks.ReentrantLock;

public class LectoresEscritoresAMal {
	
	private static final int ESCRITORES = 3;
	private static final int LECTORES = 3;
	
	// Cuantos lectores hay ahora leyendo
	private static int numLectoresBD = 0;
	
	// Solo puede haber un escritor escirbiendo por tanto no es necesario contarlos
	private static boolean escritoresBD = false;
	
	private ReentrantLock cerrojo = new ReentrantLock();
	//Para que los escritores esperen antes de empezar a escribir
	private Condition escritoresCond = cerrojo.newCondition();
	
	//Para que los lectores esperen antes de empezar a leer
	private Condition lectoresCond = cerrojo.newCondition();
	

	private void sleepRandom(long max){
		try{
			Thread.sleep((long) (Math.random()*max));
		}catch(InterruptedException e) {
			
		}
	}
	
	public void inicioLectura() {
		cerrojo.lock();
		try {
			try {
				while(escritoresBD == true || cerrojo.hasWaiters(escritoresCond)) {
					lectoresCond.await();
				}
			}catch (InterruptedException e) {
				
			}
			numLectoresBD++;
		}finally{
			cerrojo.unlock();	
		}
	}
	
	public void finLectura() {
		cerrojo.lock();
		try {
			numLectoresBD--;
			if (numLectoresBD == 0 && cerrojo.hasWaiters(escritoresCond)) {
				escritoresCond.signal();
			}
		}finally {
			cerrojo.unlock();
		}
	}
	
	public void inicioEscritura() {
		cerrojo.lock();
		try {
			try {
				while(numLectoresBD > 0 || escritoresBD == true) {
					escritoresCond.await();
				}
			}catch(InterruptedException e){
				
			}
			escritoresBD = true;
		}finally {
			cerrojo.unlock();
		}
		
	}
	
	public void finEscritura() {
		cerrojo.lock();
		try {
			escritoresBD = false;
			if (cerrojo.hasWaiters(escritoresCond)){
				escritoresCond.signal();
			}else{
				lectoresCond.signalAll();
			}
		}finally {
			cerrojo.unlock();
		}
	}
	
	public void lector() {
		while(true) {
			inicioLectura();
			System.out.println("Leer datos");
			sleepRandom(500);
			finLectura();
			System.out.println("Procesar datos");
			sleepRandom(500);
		}
	
	}
	
	public void escritor(){
		System.out.println("Generar datos");
		inicioEscritura();
		System.out.println("Escribir datos");
		sleepRandom(500);
		finEscritura();
		sleepRandom(500);
	}
	
	public void exec(){
		
		for(int i=0; i<LECTORES; i++) {
			new Thread(()-> lector(),"Lector"+ i).start();
		}
		
		for(int i=0; i<ESCRITORES; i++) {
			new Thread(()->escritor(),"Escritor" +i).start();
		}
		
	}
	
	public static void main(String [] args) throws InterruptedException {
		new LectoresEscritoresAMal().exec();
	}

}