package Ejer05_05_06;

import java.util.Arrays;
import java.util.concurrent.locks.Condition;
import java.util.concurrent.locks.ReentrantLock;

public class DataSourceManager {
	
	private static final int NUM_DS = 2;
	
	private boolean [] busyDataSource = new boolean [NUM_DS];
	
	private ReentrantLock cerrojo = new ReentrantLock(true);
	private Condition [] esperaParaDataSource = new Condition[NUM_DS];
	private Condition esperaParaAnyDataSource = cerrojo.newCondition();
	
	public DataSourceManager() {
		for (int i=0;i<NUM_DS;i++) {
			esperaParaDataSource[i] = cerrojo.newCondition();
		}
		Arrays.fill(busyDataSource, false);
	}
	
	public int accessAnyDataSource() throws InterruptedException {
		cerrojo.lock();
		
		try {
			while(busyDataSource[0] && busyDataSource[1]) {
				esperaParaAnyDataSource.await();
			}
			if (!busyDataSource[0]) {
				busyDataSource[0] = true;
				return 0;
			}else {
				busyDataSource[1] = true;
				return 1;
			}
		}finally {
			cerrojo.unlock();
		}
	}

	public void accessDataSource (int dataSource) throws InterruptedException {
		cerrojo.lock();
		
		try {
			while(busyDataSource[dataSource]) {
				esperaParaDataSource[dataSource].await();
			}
			busyDataSource[dataSource] = true;
		}finally {
			cerrojo.unlock();
		}
	}
	
	
	
	public void freeDataSource (int dataSource) {
		cerrojo.lock();
		try {
			busyDataSource[dataSource] = false;
			if(cerrojo.hasWaiters(esperaParaDataSource[dataSource])) {
				esperaParaDataSource[dataSource].signal();
			}else if(cerrojo.hasWaiters(esperaParaAnyDataSource)) {
				esperaParaAnyDataSource.signal();
			}
		}finally {
			cerrojo.unlock();
		}
	}
}