package Ejer05_05_07;

import java.util.concurrent.BrokenBarrierException;
import java.util.concurrent.CyclicBarrier;
import java.util.concurrent.Semaphore;

public class Downloader {
	
	private static final int N_FRAGMENTOS = 3;
	private static final int N_HILOS = 3;
	private static final int N_FICHEROS = 3;
	
	private static volatile int[] fichero = new int[N_FRAGMENTOS];
	
	private static volatile int posSiguienteDescargar = 0;
	
	private final static Semaphore emDescarga = new Semaphore(1);
	private static CyclicBarrier barrera =  new CyclicBarrier(N_HILOS);

	private static int descargaDatos(int numFragmento) throws InterruptedException {
		
		Thread.sleep(1000);
		return numFragmento * 2;
		
	}
	
	private static void mostrarFichero() {
		
		System.out.println("--------------------------------------------------");
		System.out.print("File = [");
		for (int i = 0; i < N_FRAGMENTOS; i++) {
			
			System.out.print(fichero[i] + ",");
		
		}
		System.out.println("]");	
	}
	
	public static void descargafichero() {
		
		try {
			emDescarga.acquire();
			while (posSiguienteDescargar < N_FRAGMENTOS) {
				int fragmentoDescargar = posSiguienteDescargar;
				posSiguienteDescargar++;
				
				emDescarga.release();
				String threadname = Thread.currentThread().getName();
				System.out.println(threadname+ ": Descargando fragmento " +fragmentoDescargar);
				
				int datodescargado = descargaDatos(fragmentoDescargar);
				
				System.out.println(threadname+ ": Escribiendo fragmento " +fragmentoDescargar);
				fichero[fragmentoDescargar] = datodescargado;

			}
		}catch (InterruptedException e) {
		}
		
	}
	
	public static void downloader() throws BrokenBarrierException  {
		
		try{
			for(int i =0; i < N_FICHEROS; i++) {
				descargafichero();
				if (barrera.getNumberWaiting() < N_HILOS-1){
					barrera.await();
				}else {
					mostrarFichero();
					posSiguienteDescargar = 0;
					barrera.await();
					}
			}
		}catch (InterruptedException e){
		}
	}
	
	public void exec() {
		
		for(int i=0;i<N_HILOS;i++) {
		new Thread(()->{
			try {
				downloader();
			} catch (BrokenBarrierException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		},"Downloader"+i).start();
			
		}
	}
	
	public static void main(String[] args) throws InterruptedException  {
		new Downloader().exec();
	}
}