package Ejer07_01;

import java.util.concurrent.ForkJoinPool;
import java.util.concurrent.RecursiveTask;

public class ParallelForSum {
	
	private static final int LONGITUD = 100;
	private int [] datos = new int [LONGITUD];
	
	public class SumaArray extends RecursiveTask <Integer>{
		
		private int inicio;
		private int fin;
		
		public SumaArray (int inicio, int fin) {
			this.inicio = inicio;
			this.fin = fin;
		}
		
		protected Integer compute() {
			
			int longitud = fin - inicio;
			
			if(longitud < 5) {
				return computeDirectly();
			} else {
				return computeInSubtasks();
			}
		}
		
		private Integer computeDirectly() {
			
			int temp = 0;
			
			for(int i=0; i<fin; i++) {
				temp = datos[i] + temp;
			}
			return temp;
		}
		
		private Integer computeInSubtasks() {
			
			int mitad = (fin - inicio)/2;
			
			SumaArray izquierda = new SumaArray(inicio, inicio + mitad);
			SumaArray derecha = new SumaArray(inicio + mitad, fin);
			
			izquierda.fork();
			derecha.fork();
			
			return izquierda.join() + derecha.join();
		}
	}
	
	public void exec() throws InterruptedException {
		
		for (int i=0; i<LONGITUD; i++) {
			datos[i] = (int) (Math.random()*10000);
		}
		
		ForkJoinPool hilos = new ForkJoinPool(10);
		SumaArray tareas = new SumaArray(0, datos.length);
		int suma = hilos.invoke(tareas);
		
		System.out.println("Suma: "+suma);
		
	}
	
	public static void main(String [] args) throws InterruptedException {
		new ParallelForSum().exec();
		
	}
}